
/******************************************************************************
*
*   FILE
*   ----
*   getEPidentifiers.c
*
*   History
*   -------
*   2013-05-14   File created
*
*******************************************************************************
*
*   This file is generated by the 'acplt_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_ksapi
#define OV_COMPILE_LIBRARY_ksapi
#endif


#include "ksapi.h"
#include "libov/ov_macros.h"
#include "ksapi_commonFuncs.h"
#include "ks_logfile.h"
#include "ksbase_helper.h"
#include "ov_ksserver_backend.h"

void ksapi_getEPidentifiers_callback(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that);

OV_DLLFNCEXPORT OV_RESULT ksapi_getEPidentifiers_constructor(
	OV_INSTPTR_ov_object 	pobj
) {
    /*
    *   local variables
    */
    OV_RESULT    result;
    OV_INSTPTR_ksapi_getEPidentifiers this = Ov_StaticPtrCast(ksapi_getEPidentifiers, pobj);
    /* do what the base class does first */
    result = ov_object_constructor(pobj);
    if(Ov_Fail(result))
         return result;

    /* do what */
    this->v_identifierList.veclen = 0;
    this->v_identifierList.value = NULL;

    return OV_ERR_OK;
}

OV_DLLFNCEXPORT void ksapi_getEPidentifiers_startup(
	OV_INSTPTR_ov_object 	pobj
) {
    /*    
    *   local variables
    */


    /* do what the base class does first */
    ksapi_KSApiCommon_startup(pobj);

    /* do what */


    return;
}

OV_DLLFNCEXPORT void ksapi_getEPidentifiers_shutdown(
	OV_INSTPTR_ov_object 	pobj
) {
    /*    
    *   local variables
    */


    /* do what */

    /* set the object's state to "shut down" */
    ksapi_KSApiCommon_shutdown(pobj);

    return;
}

OV_DLLFNCEXPORT void ksapi_getEPidentifiers_submit(
    OV_INSTPTR_ksapi_KSApiCommon          pobj
) {
	OV_INSTPTR_ksapi_getEPidentifiers	pthis = Ov_StaticPtrCast(ksapi_getEPidentifiers, pobj);
	OV_INSTPTR_ksbase_ClientBase pClient = NULL;
	OV_VTBLPTR_ksbase_ClientBase pVtblClient = NULL;
	OV_RESULT result;

	result = ksapi_KSApiCommon_prepareSubmit(pobj, &pClient, &pVtblClient);
	if(Ov_Fail(result))
		return;

		/*	do the actual submit	*/
	pVtblClient->m_requestGetEP(pClient, NULL, pthis->v_path, KS_OT_DOMAIN, pthis->v_namemask, KS_EPF_CHILDREN, (OV_INSTPTR_ov_domain) pthis, &ksapi_getEPidentifiers_callback);
	if(!(pClient->v_state & KSBASE_CLST_ERROR))
		pthis->v_status = KSAPI_COMMON_WAITINGFORANSWER;
	else
		pthis->v_status = KSAPI_COMMON_INTERNALERROR;

	return;
}

OV_DLLFNCEXPORT void ksapi_getEPidentifiers_setandsubmit(
    OV_INSTPTR_ksapi_getEPidentifiers          pobj,
	OV_STRING 									serverHost,
	OV_STRING 									serverName,
	OV_STRING 									path,
	OV_STRING 									namemask
) {
	OV_RESULT result;

	result = ksapi_KSApiCommon_genSetForSubmit(Ov_StaticPtrCast(ksapi_KSApiCommon, pobj), serverHost, serverName, path);
	if(Ov_Fail(result))
		return;

	result = ov_string_setvalue(&(pobj->v_namemask), namemask);
	if(Ov_Fail(result))
	{
		pobj->v_status = KSAPI_COMMON_INTERNALERROR;
		pobj->v_result = result;
		return;
	}

	ksapi_getVar_submit(Ov_StaticPtrCast(ksapi_KSApiCommon, pobj));

	return;
}

void ksapi_getEPidentifiers_callback(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
{
	OV_INSTPTR_ksapi_getEPidentifiers thisgEP = Ov_StaticPtrCast(ksapi_getEPidentifiers, this);
	OV_INSTPTR_ksbase_ClientBase pClient = Ov_StaticPtrCast(ksbase_ClientBase, that);
	OV_VTBLPTR_ksbase_ClientBase pVtblClient = NULL;
	OV_RESULT result;
	OV_UINT itemsLength;
	OV_OBJ_ENGINEERED_PROPS* itemsVals = NULL;
	OV_UINT i;

	if(!this || !that)
	{
		KS_logfile_error(("callback issued with NULL pointers. aborting."));
		return;
	}

	Ov_GetVTablePtr(ksbase_ClientBase, pVtblClient, pClient);

	if(!pVtblClient)
	{
		KS_logfile_error(("%s callback: could not determine Vtable of Client %s. aborting",
				this->v_identifier, that->v_identifier));
		thisgEP->v_status = KSAPI_COMMON_INTERNALERROR;
		thisgEP->v_result = OV_ERR_BADOBJTYPE;
		return;
	}
	ov_memstack_lock();
	result = pVtblClient->m_processGetEP(pClient, NULL, (OV_RESULT*) &(thisgEP->v_result), &itemsLength, &itemsVals);
	if(Ov_Fail(result))
	{
		thisgEP->v_status = KSAPI_COMMON_INTERNALERROR;
		thisgEP->v_result = result;
		ov_memstack_unlock();
		return;
	}

	if(Ov_Fail(thisgEP->v_result))
	{
		thisgEP->v_status = KSAPI_COMMON_EXTERNALERROR;
		ov_memstack_unlock();
		return;
	}

	thisgEP->v_status = KSAPI_COMMON_REQUESTCOMPLETED;


	result = Ov_SetDynamicVectorLength(&(thisgEP->v_identifierList), itemsLength, STRING);
	if(Ov_Fail(result))
	{
		thisgEP->v_status = KSAPI_COMMON_INTERNALERROR;
		thisgEP->v_result = result;
		ov_memstack_unlock();
		return;
	}

	for(i=0; i<itemsLength; i++)
	{
		result = ov_string_setvalue(&(thisgEP->v_identifierList.value[i]), itemsVals[i].identifier);
		if(Ov_Fail(result))
		{
			thisgEP->v_status = KSAPI_COMMON_INTERNALERROR;
			thisgEP->v_result = result;
			ov_memstack_unlock();
			return;
		}
	}

	ov_memstack_unlock();
	return;
}


