
/******************************************************************************
*
*   FILE
*   ----
*   AI.c
*
*   History
*   -------
*   2012-10-02   File created
*
*******************************************************************************
*
*   This file is generated by the 'acplt_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_IOdriverlib
#define OV_COMPILE_LIBRARY_IOdriverlib
#endif


#include "IOdriverlib.h"
#include "libov/ov_macros.h"

/**
 * Cascaded ifs:
 * 		SimOn switches between transport from In to Out (false) or from SimIn to Out (true)
 * 		PVSwitch switches between usage of InPV/SimInPv or TimStamp generation inside block.
 * Scale at (Sim)In ranges from 0.0 to 1.0, at Pv(Pv) from Min to Max.
 * If (Sim)In range is exceeded Pv(Pv) is Min or Max
 */
OV_DLLFNCEXPORT void IOdriverlib_AI_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
	OV_TIME now;
    OV_INSTPTR_IOdriverlib_AI pinst = Ov_StaticPtrCast(IOdriverlib_AI, pfb);

    /*SimSwitch*/
    if(pinst->v_SimOn)
    {
    	/*PvSwitch*/
    	if(pinst->v_PvSwitch)
    	{
    		if(pinst->v_SimInPv.value > 1.0)
    		{
    			pinst->v_Pv = pinst->v_Max;
    			pinst->v_PvPv.value = pinst->v_Max;
    		}
    		else if(pinst->v_SimInPv.value < 0.0)
    		{
    			pinst->v_Pv = pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_Min;
    		}
    		else
    		{
    			pinst->v_Pv = pinst->v_SimInPv.value * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_SimInPv.value * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    		}
    		pinst->v_PvPv.time = pinst->v_SimInPv.time;
    		pinst->v_PvPv.state = pinst->v_SimInPv.state;
    		pinst->v_TimeStamp = pinst->v_SimInPv.time;
    	}
    	else /*PvSwitch FALSE*/
    	{
    		ov_time_gettime(&now);
    		if(pinst->v_SimIn > 1.0)
    		{
    			pinst->v_Pv = pinst->v_Max;
    			pinst->v_PvPv.value = pinst->v_Max;
    		}
    		else if(pinst->v_SimIn < 0.0)
    		{
    			pinst->v_Pv = pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_Min;
    		}
    		else
    		{
    			pinst->v_Pv = pinst->v_SimIn * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_SimIn * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    		}
    		pinst->v_PvPv.time = now;
    		pinst->v_PvPv.state = OV_ST_NOTSUPPORTED;
    		pinst->v_TimeStamp = now;
    	}
    }
    else /*SimOn FALSE*/
    {
    	/*PvSwitch*/
    	if(pinst->v_PvSwitch)
    	{
    		if(pinst->v_InPv.value > 1.0)
    		{
    			pinst->v_Pv = pinst->v_Max;
    			pinst->v_PvPv.value = pinst->v_Max;
    		}
    		else if(pinst->v_InPv.value < 0.0)
    		{
    			pinst->v_Pv = pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_Min;
    		}
    		else
    		{
    			pinst->v_Pv = pinst->v_InPv.value * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_InPv.value * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    		}
    		pinst->v_PvPv.time = pinst->v_InPv.time;
    		pinst->v_PvPv.state = pinst->v_InPv.state;
    		pinst->v_TimeStamp = pinst->v_InPv.time;
    	}
    	else /*PvSwitch FALSE*/
    	{
    		ov_time_gettime(&now);
    		if(pinst->v_In > 1.0)
    		{
    			pinst->v_Pv = pinst->v_Max;
    			pinst->v_PvPv.value = pinst->v_Max;
    		}
    		else if(pinst->v_In < 0.0)
    		{
    			pinst->v_Pv = pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_Min;
    		}
    		else
    		{
    			pinst->v_Pv = pinst->v_In * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    			pinst->v_PvPv.value = pinst->v_In * (pinst->v_Max - pinst->v_Min) + pinst->v_Min;
    		}
    		pinst->v_PvPv.time = now;
    		pinst->v_PvPv.state = OV_ST_NOTSUPPORTED;
    		pinst->v_TimeStamp = now;
    	}
    }

    return;
}
/**
 * Initialize PVs and TimeStamp
 */
OV_DLLFNCEXPORT OV_RESULT IOdriverlib_AI_constructor(
	OV_INSTPTR_ov_object 	pobj
) {
    /*    
    *   local variables
    */
    OV_INSTPTR_IOdriverlib_AI pinst = Ov_StaticPtrCast(IOdriverlib_AI, pobj);
    OV_RESULT    result;

    /* do what the base class does first */
    result = IOdriverlib_input_constructor(pobj);
    if(Ov_Fail(result))
         return result;

    /* do what */
    pinst->v_InPv.time.secs = 0;
    pinst->v_InPv.time.usecs = 0;
    pinst->v_SimInPv.time.secs = 0;
    pinst->v_SimInPv.time.usecs = 0;
    pinst->v_PvPv.time.secs = 0;
    pinst->v_PvPv.time.usecs = 0;
    pinst->v_PvPv.state = OV_ST_NOTSUPPORTED;
    pinst->v_TimeStamp.secs = 0;
    pinst->v_TimeStamp.usecs = 0;

    return OV_ERR_OK;
}

