/*
*	Copyright (C) 2010
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   FIND.c
*
*   History
*   -------
*   2010-11-30   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "libov/ov_macros.h"
#include "libov/ov_logfile.h"
#include "libov/ov_string.h"



OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_FIND_IN1_set(
    OV_INSTPTR_iec61131stdfb_FIND          pobj,
    const OV_STRING  value
) {
    return ov_string_setvalue(&pobj->v_IN1,value);
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_FIND_IN2_set(
    OV_INSTPTR_iec61131stdfb_FIND          pobj,
    const OV_STRING  value
) {
    return ov_string_setvalue(&pobj->v_IN2,value);
}

OV_DLLFNCEXPORT OV_UINT iec61131stdfb_FIND_OUT_get(
    OV_INSTPTR_iec61131stdfb_FIND          pobj
) {
    return pobj->v_OUT;
}


OV_DLLFNCEXPORT void iec61131stdfb_FIND_destructor(OV_INSTPTR_ov_object pobj) {

	OV_INSTPTR_iec61131stdfb_FIND pinst = Ov_StaticPtrCast(iec61131stdfb_FIND, pobj);
	
	ov_string_setvalue(&pinst->v_IN1, "");
	ov_string_setvalue(&pinst->v_IN2, "");
	
	fb_functionblock_destructor(pobj);
}


OV_DLLFNCEXPORT void iec61131stdfb_FIND_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
	unsigned int i;
	unsigned int cont_loop;
	
	unsigned int length;
	unsigned int search_length;
	
	OV_BOOL found;
	
	OV_INSTPTR_iec61131stdfb_FIND pinst = Ov_StaticPtrCast(iec61131stdfb_FIND, pfb);
	
	length = ov_string_getlength(pinst->v_IN1);
	search_length = ov_string_getlength(pinst->v_IN2);
	
	found = 0;
	
	if(length >= search_length)
	{
		if(search_length && length)
		{
			for(cont_loop = 0; cont_loop <= (length - search_length) && !found ; cont_loop++)
			{
				if(pinst->v_IN1[cont_loop] == pinst->v_IN2[0])		//find first character
				{
					for(i=0; i < search_length; i++)
					{
						if(pinst->v_IN1[cont_loop + i] == pinst->v_IN2[i])
						{
							found = 1;
						}
						else
						{
							found = 0;
							break;
						}
					}
				}
			}
			
			if(found)
			{
				pinst->v_OUT = cont_loop;
			}
			else
				pinst->v_OUT = 0;

		}
		else
		{
			ov_logfile_error("%s: at least one input not specified", pinst->v_identifier);
			pinst->v_OUT = 0;
		}
	}
	else
	{
		ov_logfile_warning("%s: string in IN2 is longer than string in IN1, ich cannot be found", pinst->v_identifier);
		pinst->v_OUT = 0;
	}

    return;
}

