/*
*	Copyright (C) 2010
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   MAX.c
*
*   History
*   -------
*   2010-11-30   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "stdfb_macros.h"
#include "libov/ov_macros.h"
#include "libov/ov_logfile.h"
#include "helper.h"

#define OV_DEBUG

OV_RESULT
iec61131stdfb_MAX_setType
(OV_INSTPTR_iec61131stdfb_MAX pobj, OV_VAR_TYPE type)
{
  if (iec61131stdfb_isConnected (Ov_PtrUpCast (fb_functionblock, pobj)))
    return OV_ERR_NOACCESS;
  else
  {
    
    switch(type & OV_VT_KSMASK)
	{
		case OV_VT_BOOL:
		case OV_VT_INT:
		case OV_VT_UINT:
		case OV_VT_BYTE:
		case OV_VT_SINGLE:
		case OV_VT_DOUBLE:
		case OV_VT_STRING:
		case OV_VT_TIME:
		case OV_VT_TIME_SPAN:
		case OV_VT_BOOL_VEC:
		case OV_VT_INT_VEC:
		case OV_VT_UINT_VEC:
		case OV_VT_BYTE_VEC:
		case OV_VT_SINGLE_VEC:
		case OV_VT_DOUBLE_VEC:
		case OV_VT_STRING_VEC:
		case OV_VT_TIME_VEC:
		case OV_VT_TIME_SPAN_VEC:
			pobj->v_IN1.value.vartype = type;
			pobj->v_IN2.value.vartype = type;
			pobj->v_OUT.value.vartype = type;
			return OV_ERR_OK;
		default:
			return OV_ERR_BADPARAM;
	}
		return OV_ERR_GENERIC;
  }
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_MAX_IN1_set(
    OV_INSTPTR_iec61131stdfb_MAX          pobj,
    const OV_ANY*  value
) {
    OV_RESULT res;
  
	  if ((value->value.vartype & OV_VT_KSMASK) == (pobj->v_IN1.value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue (&pobj->v_IN1, value);
	  else
	  {
		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		iec61131stdfb_freeVec(&pobj->v_OUT);
		res = iec61131stdfb_MAX_setType (pobj, value->value.vartype); 
		if (Ov_OK (res))
		  return ov_variable_setanyvalue (&pobj->v_IN1, value);
		else return res;
	  }
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_MAX_IN2_set(
    OV_INSTPTR_iec61131stdfb_MAX          pobj,
    const OV_ANY*  value
) {
    OV_RESULT res;
  
	  if ((value->value.vartype & OV_VT_KSMASK) == (pobj->v_IN2.value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue (&pobj->v_IN2, value);
	  else
	  {
		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		iec61131stdfb_freeVec(&pobj->v_OUT);
		res = iec61131stdfb_MAX_setType (pobj, value->value.vartype); 
		if (Ov_OK (res))
		  return ov_variable_setanyvalue (&pobj->v_IN2, value);
		else return res;
	  }
}

OV_DLLFNCEXPORT OV_ANY* iec61131stdfb_MAX_OUT_get(
    OV_INSTPTR_iec61131stdfb_MAX          pobj
) {
    return &pobj->v_OUT;
}


OV_DLLFNCEXPORT void iec61131stdfb_MAX_destructor(OV_INSTPTR_ov_object pobj) {

	OV_INSTPTR_iec61131stdfb_MAX pinst = Ov_StaticPtrCast(iec61131stdfb_MAX, pobj);
	
	iec61131stdfb_freeVec(&pinst->v_IN1);
	iec61131stdfb_freeVec(&pinst->v_IN2);
	iec61131stdfb_freeVec(&pinst->v_OUT);
	fb_functionblock_destructor(pobj);
}


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_MAX_constructor(OV_INSTPTR_ov_object pobj) {

	OV_RESULT res;
	OV_INSTPTR_iec61131stdfb_MAX pinst = Ov_StaticPtrCast(iec61131stdfb_MAX, pobj);
	
	res = fb_functionblock_constructor(pobj);
	
	if(Ov_OK(res))
	{
		pinst->v_IN1.value.valueunion.val_double = 0;
		pinst->v_IN2.value.valueunion.val_double = 0;
		pinst->v_OUT.value.valueunion.val_double = 0;
		pinst->v_IN1.value.vartype = OV_VT_SINGLE;
		pinst->v_IN2.value.vartype = OV_VT_SINGLE;
		pinst->v_OUT.value.vartype = OV_VT_SINGLE;
		return OV_ERR_OK;
	}
	else
		return res;
}

OV_DLLFNCEXPORT void iec61131stdfb_MAX_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
	
	unsigned int i;
	unsigned int s_length, l_length;
	OV_BOOL longer;
	
    OV_INSTPTR_iec61131stdfb_MAX pinst = Ov_StaticPtrCast(iec61131stdfb_MAX, pfb);
	
	iec61131stdfb_freeVec(&pinst->v_OUT);
	
	switch(pinst->v_IN1.value.vartype & OV_VT_KSMASK)
	{
		case OV_VT_BOOL:
			pinst->v_OUT.value.vartype = OV_VT_BOOL;
			if((pinst->v_IN1.value.valueunion.val_bool == TRUE) || (pinst->v_IN2.value.valueunion.val_bool == FALSE))	//TRUE > FALSE, in case of equality IN1 
			{	
				pinst->v_OUT.value.valueunion.val_bool = pinst->v_IN1.value.valueunion.val_bool;
			}
			else
			{
				pinst->v_OUT.value.valueunion.val_bool = pinst->v_IN2.value.valueunion.val_bool;
			}
		break;
		
		case OV_VT_BYTE:
			STDFB_SEL_MAX(BYTE, byte);
		break;
		
		case OV_VT_INT:
			STDFB_SEL_MAX(INT, int);
		break;
		
		case OV_VT_UINT:
			STDFB_SEL_MAX(UINT, uint);
		break;
		
		case OV_VT_SINGLE:
			STDFB_SEL_MAX(SINGLE, single);
		break;
		
		case OV_VT_DOUBLE:
			STDFB_SEL_MAX(DOUBLE, double);
		break;
		
		case OV_VT_STRING:
			pinst->v_OUT.value.vartype = OV_VT_STRING;
			if(ov_string_compare(pinst->v_IN1.value.valueunion.val_string, pinst->v_IN2.value.valueunion.val_string) >= 0)
			{
				if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string, pinst->v_IN1.value.valueunion.val_string)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
			}
			else
			{
				if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string, pinst->v_IN2.value.valueunion.val_string)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
			}
		break;
		
		case OV_VT_TIME:
			pinst->v_OUT.value.vartype = OV_VT_TIME;
			if(pinst->v_IN1.value.valueunion.val_time.secs > pinst->v_IN2.value.valueunion.val_time.secs)
			{
				pinst->v_OUT.value.valueunion.val_time.secs = pinst->v_IN1.value.valueunion.val_time.secs;
				pinst->v_OUT.value.valueunion.val_time.usecs = pinst->v_IN1.value.valueunion.val_time.usecs;
			}
			else
			{
				if((pinst->v_IN1.value.valueunion.val_time.secs == pinst->v_IN2.value.valueunion.val_time.secs)
					&& (pinst->v_IN1.value.valueunion.val_time.usecs >= pinst->v_IN2.value.valueunion.val_time.usecs))
				{
					pinst->v_OUT.value.valueunion.val_time.secs = pinst->v_IN1.value.valueunion.val_time.secs;
					pinst->v_OUT.value.valueunion.val_time.usecs = pinst->v_IN1.value.valueunion.val_time.usecs;
				}
				else
				{
					pinst->v_OUT.value.valueunion.val_time.secs = pinst->v_IN2.value.valueunion.val_time.secs;
					pinst->v_OUT.value.valueunion.val_time.usecs = pinst->v_IN2.value.valueunion.val_time.usecs;
				}
			}
		break;
		
		case OV_VT_TIME_SPAN:
			pinst->v_OUT.value.vartype = OV_VT_TIME_SPAN;
			if(pinst->v_IN1.value.valueunion.val_time_span.secs > pinst->v_IN2.value.valueunion.val_time_span.secs)
			{
				pinst->v_OUT.value.valueunion.val_time_span.secs = pinst->v_IN1.value.valueunion.val_time_span.secs;
				pinst->v_OUT.value.valueunion.val_time_span.usecs = pinst->v_IN1.value.valueunion.val_time_span.usecs;
			}
			else
			{
				if((pinst->v_IN1.value.valueunion.val_time_span.secs == pinst->v_IN2.value.valueunion.val_time_span.secs)
					&& (pinst->v_IN1.value.valueunion.val_time_span.usecs >= pinst->v_IN2.value.valueunion.val_time_span.usecs))
				{
					pinst->v_OUT.value.valueunion.val_time_span.secs = pinst->v_IN1.value.valueunion.val_time_span.secs;
					pinst->v_OUT.value.valueunion.val_time_span.usecs = pinst->v_IN1.value.valueunion.val_time_span.usecs;
				}
				else
				{
					pinst->v_OUT.value.valueunion.val_time_span.secs = pinst->v_IN2.value.valueunion.val_time_span.secs;
					pinst->v_OUT.value.valueunion.val_time_span.usecs = pinst->v_IN2.value.valueunion.val_time_span.usecs;
				}
			}
		break;
		
	/******************** Vectors ****************************************/
	/**** treated as data fields, maximum is chosen elementwise*************/
			
		case OV_VT_BYTE_VEC:
			STDFB_SEL_MAX_VEC(BYTE, byte);
			
		break;
		
		case OV_VT_BOOL_VEC:
			pinst->v_OUT.value.vartype = OV_VT_BOOL_VEC;
			if(pinst->v_IN1.value.valueunion.val_bool_vec.veclen >= pinst->v_IN2.value.valueunion.val_bool_vec.veclen)
			{	
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_bool_vec, pinst->v_IN1.value.valueunion.val_bool_vec.veclen, BOOL)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 1;			//marks longer vector (1: IN1, 0: IN2)
				s_length = pinst->v_IN2.value.valueunion.val_bool_vec.veclen;
				l_length = pinst->v_IN1.value.valueunion.val_bool_vec.veclen;
			}
			else
			{
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_bool_vec, pinst->v_IN2.value.valueunion.val_bool_vec.veclen, BOOL)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 0;
				s_length = pinst->v_IN1.value.valueunion.val_bool_vec.veclen;
				l_length = pinst->v_IN2.value.valueunion.val_bool_vec.veclen;
			}
			for(i=0; i < s_length; i++)	//iterate till end of shorter vector
			{
				if(pinst->v_IN1.value.valueunion.val_bool_vec.value[i] || (!pinst->v_IN2.value.valueunion.val_bool_vec.value[i]))
					pinst->v_OUT.value.valueunion.val_bool_vec.value[i] = pinst->v_IN1.value.valueunion.val_bool_vec.value[i];
				else
					pinst->v_OUT.value.valueunion.val_bool_vec.value[i] = pinst->v_IN2.value.valueunion.val_bool_vec.value[i];
			}
			if(longer)	//IN1 is longer vector (or same length)
			{
				for(i=s_length; i < l_length; i++)	//iterate till end
					pinst->v_OUT.value.valueunion.val_bool_vec.value[i] = pinst->v_IN1.value.valueunion.val_bool_vec.value[i];
			}
			else
			{
				for(i=s_length; i < l_length; i++)
					pinst->v_OUT.value.valueunion.val_bool_vec.value[i] = pinst->v_IN2.value.valueunion.val_bool_vec.value[i];
			}
		break;
		
		case OV_VT_UINT_VEC:
			STDFB_SEL_MAX_VEC(UINT, uint);
		break;
		
		case OV_VT_INT_VEC:
			STDFB_SEL_MAX_VEC(INT, int);
		break;
		
		case OV_VT_SINGLE_VEC:
			STDFB_SEL_MAX_VEC(SINGLE, single);
		break;
		
		case OV_VT_DOUBLE_VEC:
			STDFB_SEL_MAX_VEC(DOUBLE, double);
		break;
		
		case OV_VT_STRING_VEC:
			pinst->v_OUT.value.vartype = OV_VT_STRING_VEC;
			if(pinst->v_IN1.value.valueunion.val_string_vec.veclen >= pinst->v_IN2.value.valueunion.val_string_vec.veclen)
			{	
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_string_vec, pinst->v_IN1.value.valueunion.val_string_vec.veclen, STRING)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 1;			//marks longer vector (1: IN1, 0: IN2)
				s_length = pinst->v_IN2.value.valueunion.val_string_vec.veclen;
				l_length = pinst->v_IN1.value.valueunion.val_string_vec.veclen;
			}
			else
			{
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_string_vec, pinst->v_IN2.value.valueunion.val_string_vec.veclen, STRING)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 0;
				s_length = pinst->v_IN1.value.valueunion.val_string_vec.veclen;
				l_length = pinst->v_IN2.value.valueunion.val_string_vec.veclen;
			}
			
			for(i=0; i < s_length; i++)	//iterate till end of shorter vector
			{
				if(ov_string_compare(pinst->v_IN1.value.valueunion.val_string_vec.value[i], pinst->v_IN2.value.valueunion.val_string_vec.value[i]) >= 0)
					if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN1.value.valueunion.val_string_vec.value[i])))
					{
						ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
					}
					else
						continue;
				else
					if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN2.value.valueunion.val_string_vec.value[i])))
					{
						ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
					}
			}
			if(longer)	//IN1 is longer vector (or same length)
			{
				for(i=s_length; i < l_length; i++)	//iterate till end
					if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN1.value.valueunion.val_string_vec.value[i])))
					{
						ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
					}
			}
			else
			{
				for(i=s_length; i < l_length; i++)
					if(Ov_Fail(ov_string_setvalue(&pinst->v_OUT.value.valueunion.val_string_vec.value[i], pinst->v_IN2.value.valueunion.val_string_vec.value[i])))
					{
						ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
						return;
					}
			}
			
		break;
		
		case OV_VT_TIME_VEC:
			pinst->v_OUT.value.vartype = OV_VT_TIME_VEC;
			if(pinst->v_IN1.value.valueunion.val_time_vec.veclen >= pinst->v_IN2.value.valueunion.val_time_vec.veclen)
			{	
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_vec, pinst->v_IN1.value.valueunion.val_time_vec.veclen, TIME)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 1;			//marks longer vector (1: IN1, 0: IN2)
				s_length = pinst->v_IN2.value.valueunion.val_time_vec.veclen;
				l_length = pinst->v_IN1.value.valueunion.val_time_vec.veclen;
			}
			else
			{
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_vec, pinst->v_IN2.value.valueunion.val_time_vec.veclen, TIME)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 0;
				s_length = pinst->v_IN1.value.valueunion.val_time_vec.veclen;
				l_length = pinst->v_IN2.value.valueunion.val_time_vec.veclen;
			}
			for(i=0; i < s_length; i++)	//iterate till end of shorter vector
			{
				if(pinst->v_IN1.value.valueunion.val_time_vec.value[i].secs  > pinst->v_IN2.value.valueunion.val_time_vec.value[i].secs)	//if secs in IN1 is larger
				{
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].usecs;
				}
				else
				{
					if((pinst->v_IN1.value.valueunion.val_time_vec.value[i].secs  < pinst->v_IN2.value.valueunion.val_time_vec.value[i].secs)	//if secs in IN2 is larger OR usecs in IN2 is larger (then secs are equal)
						|| (pinst->v_IN1.value.valueunion.val_time_vec.value[i].usecs  < pinst->v_IN2.value.valueunion.val_time_vec.value[i].usecs))
					{
						pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = pinst->v_IN2.value.valueunion.val_time_vec.value[i].secs;
						pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = pinst->v_IN2.value.valueunion.val_time_vec.value[i].usecs;
					}
					else
					{
						pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].secs;
						pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].usecs;
					}
				}
			}
			if(longer)	//IN1 is longer vector (or same length)
			{
				for(i=s_length; i < l_length; i++)	//iterate till end
				{
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_vec.value[i].usecs;
				}
			}
			else
			{
				for(i=s_length; i < l_length; i++)
				{
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].secs = pinst->v_IN2.value.valueunion.val_time_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_vec.value[i].usecs = pinst->v_IN2.value.valueunion.val_time_vec.value[i].usecs;
				}
			}
		break;
		
		case OV_VT_TIME_SPAN_VEC:
			pinst->v_OUT.value.vartype = OV_VT_TIME_SPAN_VEC;
			if(pinst->v_IN1.value.valueunion.val_time_span_vec.veclen >= pinst->v_IN2.value.valueunion.val_time_span_vec.veclen)
			{	
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_span_vec, pinst->v_IN1.value.valueunion.val_time_span_vec.veclen, TIME_SPAN)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 1;			//marks longer vector (1: IN1, 0: IN2)
				s_length = pinst->v_IN2.value.valueunion.val_time_span_vec.veclen;
				l_length = pinst->v_IN1.value.valueunion.val_time_span_vec.veclen;
			}
			else
			{
				if(Ov_Fail(Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_time_span_vec, pinst->v_IN2.value.valueunion.val_time_span_vec.veclen, TIME_SPAN)))
				{
					ov_logfile_error("%s: allocation of memory failed, no operation performed", pinst->v_identifier);
					return;
				}
				longer = 0;
				s_length = pinst->v_IN1.value.valueunion.val_time_span_vec.veclen;
				l_length = pinst->v_IN2.value.valueunion.val_time_span_vec.veclen;
			}
			for(i=0; i < s_length; i++)	//iterate till end of shorter vector
			{
				if(pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].secs  > pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].secs)	//if secs in IN1 is larger
				{
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].usecs;
				}
				else
				{
					if((pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].secs  < pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].secs)	//if secs in IN2 is larger OR usecs in IN2 is larger (then secs are equal)
						|| (pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].usecs  < pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].usecs))
					{
						pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].secs;
						pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].usecs;
					}
					else
					{
						pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].secs;
						pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].usecs;
					}
				}
			}
			if(longer)	//IN1 is longer vector (or same length)
			{
				for(i=s_length; i < l_length; i++)	//iterate till end
				{
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = pinst->v_IN1.value.valueunion.val_time_span_vec.value[i].usecs;
				}
			}
			else
			{
				for(i=s_length; i < l_length; i++)
				{
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].secs = pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].secs;
					pinst->v_OUT.value.valueunion.val_time_span_vec.value[i].usecs = pinst->v_IN2.value.valueunion.val_time_span_vec.value[i].usecs;
				}
			}
		break;
		
		default:
			ov_logfile_error("%s: the given datatye is currently not supported within this block", pinst->v_identifier);
			pinst->v_OUT.value.vartype = OV_VT_BOOL;
			pinst->v_OUT.value.valueunion.val_bool = 0;
		break;
	}
		
	if(pinst->v_OUT.value.vartype & OV_VT_ISVECTOR)	//if vectors are MAXed and one input has a timestamp, output timestamp is set to current system time
	{
		STDFB_TIMESTAMP_NEW;
	}
	
	/************** handling states and timestamps ********************************/
	STDFB_TIMESTAMP_NEW	
	
	
	
    return;
}

