/*
*	Copyright (C) 2010
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   StateWatch.c
*
*   History
*   -------
*   2011-04-29   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "libov/ov_macros.h"
#include "helper.h"



OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_StateWatch_constructor(OV_INSTPTR_ov_object pobj) {

	OV_RESULT res;
	OV_INSTPTR_iec61131stdfb_StateWatch pinst = Ov_StaticPtrCast(iec61131stdfb_StateWatch, pobj);
	
	res = fb_functionblock_constructor(pobj);
	if(Ov_OK(res))
	{
		pinst->v_IN.value.valueunion.val_double = 0;
		pinst->v_OUT.value.valueunion.val_double = 0;
		pinst->v_IN.value.vartype = OV_VT_SINGLE;
		pinst->v_OUT.value.vartype = OV_VT_SINGLE;
		return OV_ERR_OK;
	}
	else
		return res;
}

OV_DLLFNCEXPORT void iec61131stdfb_StateWatch_shutdown(OV_INSTPTR_ov_object pobj) {

	OV_INSTPTR_iec61131stdfb_StateWatch pinst = Ov_StaticPtrCast(iec61131stdfb_StateWatch, pobj);
	
	iec61131stdfb_freeVec(&pinst->v_IN);
	iec61131stdfb_freeVec(&pinst->v_OUT);
	fb_functionblock_shutdown(pobj);
}


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_StateWatch_IN_set(
    OV_INSTPTR_iec61131stdfb_StateWatch          pobj,
    const OV_ANY*  value
) {
    OV_RESULT res;
	
	if((value->value.vartype & OV_VT_KSMASK) != (pobj->v_IN.value.vartype & OV_VT_KSMASK))
		if(iec61131stdfb_isConnected (Ov_PtrUpCast (fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;
	
	pobj->v_CurState = value->state;
		
	if(value->value.vartype & OV_VT_HAS_STATE)
	{
		pobj->v_HasState = TRUE;
		switch(value->state)
		{
			case OV_ST_GOOD:
				pobj->v_CGood = TRUE;
				pobj->v_CBad = FALSE;
				pobj->v_CQuestionable = FALSE;
				pobj->v_CUnknown = FALSE;
				if(!pobj->v_Reset)
					pobj->v_HGood = TRUE;
			break;
			
			case OV_ST_UNKNOWN:
				pobj->v_CGood = FALSE;
				pobj->v_CBad = FALSE;
				pobj->v_CQuestionable = FALSE;
				pobj->v_CUnknown = TRUE;
				if(!pobj->v_Reset)
					pobj->v_HUnknown = TRUE;
			break;
			
			case OV_ST_QUESTIONABLE:
				pobj->v_CGood = FALSE;
				pobj->v_CBad = FALSE;
				pobj->v_CQuestionable = TRUE;
				pobj->v_CUnknown = FALSE;
				if(!pobj->v_Reset)
					pobj->v_HQuestionable = TRUE;
			break;
			
			case OV_ST_BAD:
				pobj->v_CGood = FALSE;
				pobj->v_CBad = TRUE;
				pobj->v_CQuestionable = FALSE;
				pobj->v_CUnknown = FALSE;
				if(!pobj->v_Reset)
					pobj->v_HBad = TRUE;
			break;
			
			default:	//undefined state => bad
				pobj->v_CGood = FALSE;
				pobj->v_CBad = TRUE;
				pobj->v_CQuestionable = FALSE;
				pobj->v_CUnknown = FALSE;
				if(!pobj->v_Reset)
					pobj->v_HBad = TRUE;
			break;
		}
		
	}
	else
	{
		pobj->v_HasState = FALSE;
		pobj->v_CGood = FALSE;
		pobj->v_CBad = FALSE;
		pobj->v_CQuestionable = FALSE;
		pobj->v_CUnknown = TRUE;
	}
		
	res = ov_variable_setanyvalue(&pobj->v_OUT, value);
	if(Ov_Fail(res))
		return res;
		
	return ov_variable_setanyvalue(&pobj->v_IN, value);
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_StateWatch_Reset_set(
    OV_INSTPTR_iec61131stdfb_StateWatch          pobj,
    const OV_BOOL  value
) {
    if(value)
	{
		pobj->v_HGood = FALSE;
		pobj->v_HBad = FALSE;
		pobj->v_HQuestionable = FALSE;
		pobj->v_HUnknown = FALSE;
	}
	pobj->v_Reset = value;
    return OV_ERR_OK;
}

OV_DLLFNCEXPORT void iec61131stdfb_StateWatch_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
					//empty, States are handeled within set accessors
    return;
}

